Unit aer16e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure aer16e(N :Integer; var D :Array of Extended;
                var E2 :Array of Extended; var IERR :Integer);

implementation

procedure aer16e(N :Integer; var D :Array of Extended;
                var E2 :Array of Extended; var IERR :Integer);
var
I,J,L,M,II,L1,MML :Integer;
B,C,F,G,H,P,R,S,MACHEP :Extended;
const
SYS051 :Extended = 1.1107652e-16;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14;
begin
MACHEP := SYS051;
IERR := 0;
if ( N = 1 ) 
 then goto _14;
for I:=2 to N do
 begin
_1:
  E2[I-2] := E2[I-1];
 end;
F := 0.0e0;
B := 0.0e0;
E2[N-1] := 0.0e0;
for L:=1 to N do
 begin
  J := 0;
  H := MACHEP*(Abs(D[L-1])+Sqrt(E2[L-1]));
  if ( B > H ) 
   then goto _2;
  B := H;
  C := B*B;
{  ********** }
_2:
  for M:=L to N do
   begin
    if ( E2[M-1] <= C ) 
     then goto _4;
{  ********** }
_3:
   end;
_4:
  if ( M = L ) 
   then goto _8;
_5:
  if ( J = 30 ) 
   then goto _13;
  J := J+1;
{  ********** }
  L1 := L+1;
  S := Sqrt(E2[L-1]);
  G := D[L-1];
  P := (D[L1-1]-G)/(2.0e0*S);
  if ( Abs(P) > 1.e0 ) 
   then R := Abs(P)*Sqrt(1.e0+IntPower(1/P,2));
  if ( Abs(P) <= 1.e0 ) 
   then R := Sqrt(P*P+1.e0);
  D[L-1] := S/(P+Sign(R,P));
  H := G-D[L-1];
  for I:=L1 to N do
   begin
_6:
    D[I-1] := D[I-1]-H;
   end;
  F := F+H;
{  ********** }
  G := D[M-1];
  if ( G = 0.0e0 ) 
   then G := B;
  H := G;
  S := 0.0e0;
  MML := M-L;
{  ********** }
  for II:=1 to MML do
   begin
    I := M-II;
    P := G*H;
    R := P+E2[I-1];
    E2[I+0] := S*R;
    S := E2[I-1]/R;
    D[I+0] := H+S*(H+D[I-1]);
    G := D[I-1]-E2[I-1]/G;
    if ( G = 0.0e0 ) 
     then G := B;
    H := G*P/R;
_7:
   end;
  E2[L-1] := S*G;
  D[L-1] := H;
{  ********** }
  if ( H = 0.0e0 ) 
   then goto _8;
  if ( Abs(E2[L-1]) <= Abs(C/H) ) 
   then goto _8;
  E2[L-1] := H*E2[L-1];
  if ( E2[L-1] <> 0.0e0 ) 
   then goto _5;
_8:
  P := D[L-1]+F;
{  ********** }
  if ( L = 1 ) 
   then goto _10;
{  ********** }
  for II:=2 to L do
   begin
    I := L+2-II;
    if ( P >= D[I-2] ) 
     then goto _11;
    D[I-1] := D[I-2];
_9:
   end;
_10:
  I := 1;
_11:
  D[I-1] := P;
_12:
 end;
goto _14;
_13:
IERR := L;
_14:
end;

end.
